Subject: Re: bug#24340: insert-file-contents calls before-change-functions too late

From: Eli Zaretskii <[email-masked]>
Date: Wed, 31 Aug 2016 18:03:12 +0300

> From: Stefan Monnier <[email-masked]>
> Cc: [email-masked]
> Date: Wed, 31 Aug 2016 10:48:09 -0400
> 
> > I'm sorry, but I must insist.  The change I proposed is the only one
> > in insert-file-contents for that use case that I'm prepared to
> > consider in the current situation.  (We could also leave this bug
> > open, until such time as a more thorough refactoring is done of the
> > related functionalities.)  Deeper changes are exactly the can of worms
> > that I don't want to open to fix just this one use case, especially
> > since Emacs 25.2 will almost certainly be branched from what now is
> > the master branch.  Such deeper changes were what Alan proposed in the
> > first place (with a similar patch), and I already said I didn't want
> > to do that.
> 
> Right: I do not intend for my patch to go to 25.2.  But for Emacs-26,
> it seems there's plenty of time to find and fix any possible fallout.

Since I believe master will be used for 25.2, we cannot currently push
anything that must wait for 26.

> > I think a cleaner way is to change the model of how we partition
> > piecemeal changes, when we signal the changes and when don't, when we
> > ask the user about supersession-threat, etc.  The current model is
> > fundamentally flawed, if we want to use the buffer-change hooks in the
> > ways that emerged from these discussions.
> 
> All I care about is for any change to the buffer to be announced by
> a prior b-c-f.

My proposed simple change satisfies this requirement, albeit the
effect is less optimal.